| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Member Functions | Private Attributes | List of all members
MemStatAuditor Class Reference

Just a minor modification of MemoryAuditor to allow the output memory statistics table to be printed. More...

`#include <GaudiAud/MemStatAudit.h>`

Inheritance diagram for MemStatAuditor:
[legend]
Collaboration diagram for MemStatAuditor:
[legend]

## Public Member Functions
| MemStatAuditor (const std::string &name, ISvcLocator *pSvcLocator)
| local More...
| ~MemStatAuditor () override=default
StatusCode | initialize () override
Public Member Functions inherited from MemoryAuditor
| MemoryAuditor (const std::string &name, ISvcLocator *pSvcLocator)
Public Member Functions inherited from CommonAuditor
| CommonAuditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
virtual | ~CommonAuditor ()=default
| Destructor. More...
virtual void | before (StandardEventType evt, const std::string &caller)
virtual void | before (StandardEventType evt, INamedInterface *caller)
virtual void | before (CustomEventTypeRef evt, const std::string &caller)
virtual void | before (CustomEventTypeRef evt, INamedInterface *caller)
virtual void | after (StandardEventType evt, const std::string &caller, const StatusCode &sc)
virtual void | after (StandardEventType evt, INamedInterface *caller, const StatusCode &sc)
virtual void | after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc)
virtual void | after (CustomEventTypeRef evt, INamedInterface *caller, const StatusCode &sc)
Public Member Functions inherited from Auditor
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| ~Auditor () override=default
| Destructor. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysFinalize () override
| Finalization method invoked by the framework. More...
void | before (StandardEventType, INamedInterface *) override
| The following methods are meant to be implemented by the child class... More...
void | before (StandardEventType, const std::string &) override
void | before (CustomEventTypeRef, INamedInterface *) override
void | before (CustomEventTypeRef, const std::string &) override
void | after (StandardEventType, INamedInterface *, const StatusCode &) override
void | after (StandardEventType, const std::string &, const StatusCode &) override
void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &) override
void | after (CustomEventTypeRef, const std::string &, const StatusCode &) override
void | beforeInitialize (INamedInterface *) override
void | afterInitialize (INamedInterface *) override
void | beforeReinitialize (INamedInterface *) override
void | afterReinitialize (INamedInterface *) override
void | beforeExecute (INamedInterface *) override
void | afterExecute (INamedInterface *, const StatusCode &) override
void | beforeFinalize (INamedInterface *) override
void | afterFinalize (INamedInterface *) override
void | beforeBeginRun (INamedInterface *) override
void | afterBeginRun (INamedInterface *) override
void | beforeEndRun (INamedInterface *) override
void | afterEndRun (INamedInterface *) override
virtual StatusCode | finalize ()
const std::string & | name () const override
bool | isEnabled () const override
SmartIF< ISvcLocator > & | serviceLocator () const
| The standard service locator. More...
template<class T >
StatusCode | service (const std::string &name, T *&svc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T = IService>
SmartIF< T > | service (const std::string &name, bool createIf=false) const
StatusCode | setProperty (const Property &p) override
| Set a value of a property of an auditor. More...
StatusCode | setProperty (const std::string &s) override
| Implementation of IProperty::setProperty. More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| Implementation of IProperty::setProperty. More...
StatusCode | getProperty (Property *p) const override
| Get the value of a property. More...
const Property & | getProperty (const std::string &name) const override
| Get the property by name. More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| Implementation of IProperty::getProperty. More...
const std::vector< Property * > & | getProperties () const override
| Get all properties. More...
bool | hasProperty (const std::string &name) const override
| Implementation of IProperty::hasProperty. More...
template<class TYPE >
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | setProperties ()
| Set the auditor's properties. More...
template<class T >
Property * | declareProperty (const std::string &name, T &property, const std::string &doc="none") const
| Declare the named property. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...

## Private Member Functions
void | i_before (CustomEventTypeRef evt, const std::string &caller) override
| Re-implement i_before to avoid monitoring the memory usage before a function. More...
void | i_printinfo (const std::string &msg, CustomEventTypeRef evt, const std::string &caller) override
| Report the memory usage. More...
SmartIF< IChronoStatSvc > & | statSvc ()

## Private Attributes
SmartIF< IChronoStatSvc > | m_stat
double | m_vSize = -1
| vsize of the previous call to printinfo More...

## Additional Inherited Members
Public Types inherited from Auditor
typedef Gaudi::PluginService::Factory< IAuditor *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from CommonMessaging< implements< IAuditor, IProperty > >
using | base_class = CommonMessaging
Protected Member Functions inherited from MemoryAuditor
virtual void | i_after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc)
| Default (catch-all) "after" Auditor hook. More...
Protected Member Functions inherited from CommonAuditor
bool | i_auditEventType (const std::string &evt)
| Check if we are requested to audit the passed event type. More...
void | i_updateCustomTypes (Property &)
| Update handler for the obsolete property CustomEventTypes. More...
Protected Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Static Protected Member Functions inherited from MemoryAuditor
static bool | getProcInfo (procInfo &info)
| Get the process informations. More...
Protected Attributes inherited from CommonAuditor
StringArrayProperty | m_types
StringArrayProperty | m_customTypes

## Detailed Description

Just a minor modification of MemoryAuditor to allow the output memory statistics table to be printed.

Author
  Vanya Belyaev
  Marco Clemencic

Date
  04/02/2001

Definition at line 15 of file MemStatAuditor.h.

## Constructor & Destructor Documentation

MemStatAuditor::MemStatAuditor | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator
| ) |  |

local

Definition at line 18 of file MemStatAuditor.cpp.

18 :
19 MemoryAuditor(name, pSvcLocator)
20 {
21 }
MemoryAuditor::MemoryAuditor
MemoryAuditor(const std::string &name, ISvcLocator *pSvcLocator)
Definition: MemoryAuditor.cpp:15

MemStatAuditor::~MemStatAuditor | ( |  | ) |
| override default

## Member Function Documentation

void MemStatAuditor::i_before | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| override private virtual

Re-implement i_before to avoid monitoring the memory usage before a function.

Reimplemented from MemoryAuditor.

Definition at line 35 of file MemStatAuditor.cpp.

35 {
36 // It's not interesting to monitor the memory usage before the methods.
37 }

void MemStatAuditor::i_printinfo | ( | const std::string & | msg,
|  | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| override private virtual

Report the memory usage.

Reimplemented from MemoryAuditor.

Definition at line 39 of file MemStatAuditor.cpp.

39 {
40 // cannot be exactly 0
41 double deltaVSize = 0.00001;
42
43 procInfo pInfo;
44 if (getProcInfo(pInfo)) {
45
46 if (pInfo.vsize > 0) {
47 if (m_vSize > 0){
48 deltaVSize = pInfo.vsize - m_vSize;
49 }
50 // store the current VSize to be able to monitor the increment
51 m_vSize = pInfo.vsize;
52 }
53
54 info() << msg << " " << caller << " " << evt <<
55 " \tvirtual size = " << pInfo.vsize << " MB" <<
56 " \tresident set size = " << pInfo.rss << " MB" <<
57 " deltaVsize = " << deltaVSize << " MB" << endmsg;
58 }
59 // fill the stat for every call, not just when there is a change
60 // only monitor the increment in VSize
61 // Stat stv(statSvc(), caller + ":VMemUsage", pInfo.vsize);
62 // Stat str(statSvc(), caller + ":RMemUsage", pInfo.rss);
63 Stat sts(statSvc(), caller + ":VMem", deltaVSize);
64 }
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:124
Stat
Small wrapper class for easy manipulation with generic counters and IStatSvc&ICounterSvc interface...
Definition: Stat.h:46
procInfo::rss
double rss
Definition: ProcStats.h:38
read_lhcb_event_file.evt
tuple evt
Definition: read_lhcb_event_file.py:14
MemStatAuditor::m_vSize
double m_vSize
vsize of the previous call to printinfo
Definition: MemStatAuditor.h:31
MemoryAuditor::getProcInfo
static bool getProcInfo(procInfo &info)
Get the process informations.
Definition: MemoryAuditor.h:27
procInfo::vsize
double vsize
Definition: ProcStats.h:37
MemStatAuditor::statSvc
SmartIF< IChronoStatSvc > & statSvc()
Definition: MemStatAuditor.h:27
procInfo
Definition: ProcStats.h:16
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode MemStatAuditor::initialize | ( |  | ) |
| override virtual

Reimplemented from Auditor.

Definition at line 23 of file MemStatAuditor.cpp.

23 {
24 StatusCode sc = CommonAuditor::initialize();
25 if (UNLIKELY(sc.isFailure())) return sc;
26
27 m_stat = serviceLocator()->service("ChronoStatSvc");
28 if (UNLIKELY(!m_stat.get())) {
29 error() << "Cannot get ChronoStatSvc" << endmsg;
30 return StatusCode::FAILURE;
31 }
32 return StatusCode::SUCCESS;
33 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:126
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:86
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:76
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:78
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:118
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
Auditor::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const
The standard service locator.
Definition: Auditor.cpp:211
MemStatAuditor::m_stat
SmartIF< IChronoStatSvc > m_stat
Definition: MemStatAuditor.h:28
Auditor::initialize
virtual StatusCode initialize()
Definition: Auditor.cpp:82
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

SmartIF<IChronoStatSvc>& MemStatAuditor::statSvc | ( |  | ) |
| inline private

Definition at line 27 of file MemStatAuditor.h.

27 { return m_stat; }
MemStatAuditor::m_stat
SmartIF< IChronoStatSvc > m_stat
Definition: MemStatAuditor.h:28

## Member Data Documentation

SmartIF<IChronoStatSvc> MemStatAuditor::m_stat
| private

Definition at line 28 of file MemStatAuditor.h.

double MemStatAuditor::m_vSize = -1
| private

vsize of the previous call to printinfo

Definition at line 31 of file MemStatAuditor.h.

The documentation for this class was generated from the following files:

- GaudiAud/src/MemStatAuditor.h
- GaudiAud/src/MemStatAuditor.cpp